/************************************************************
  Copyright (C) 2005-2023 RobSmithDev
  https://robsmithdev.co.uk
*************************************************************/  

#ifndef CLOUD_CREATOR_H
#define CLOUD_CREATOR_H


#define CLOUD_MAX_LAYERS 6


#define SKY_COLOR RGB(0x32,0x99,0xCC)

	


class CCloud 
{
	private:
		UCHAR* pCloud;
		int thisW,thisH;
		UCHAR SkyCoverTable[256];

		bool SmoothImage();
		void FreeCloud();
		void CalcLookups(UCHAR SkyCover,UCHAR bCloudSharpness);
		int Noise1(int x,int y, int seed);
		


	public:
		
		HBITMAP ConvertToBitmap(DWORD BackgroundColor);
		// Creates clouds and returns a handle to a new bitmap to them (CloudDetail is 0..CLOUD_MAX_LAYERS-1
		bool CreateClouds(int CloudDetail, int Width,int Height,int CloudSeed,UCHAR SkyCover,UCHAR bCloudSharpness);

		// Rolls the cloud information so many pixels in each direction
		bool RollCloud(int x,int y);

		// Joins clouds together
		HBITMAP AnimateClouds(DWORD SkyColor,UCHAR CloudCover, CCloud* pCloudList, ...); 

		

		CCloud();
		~CCloud();
		UCHAR* GetCloudPointer();
		bool CreateCloudMemory(int width,int height);
		bool CreateNoise(int time, int width,int height);
		bool CreateFromTile(int width,int height,CCloud* src);
		bool SampleUpCloud(CCloud* dest);   // Creates a copy of this cloud image by sample-ing up this cloud
		int GetWidth();
		int GetHeight();

};



#endif