// ColorsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Colors.h"
#include "ColorsDlg.h"
#include <math.h>

#define BITMAPHEIGHT   1024
#define BITMAPWIDTH    1024
#define SPEED 10


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif





/////////////////////////////////////////////////////////////////////////////
// CColorsDlg dialog


CColorsDlg::CColorsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CColorsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorsDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CColorsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorsDlg)
	DDX_Control(pDX, IDC_SHARP, m_sharp);
	DDX_Control(pDX, IDC_COVER, m_cover);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CColorsDlg, CDialog)
	//{{AFX_MSG_MAP(CColorsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorsDlg message handlers

BOOL CColorsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	memset(&BitmapInfo,0,sizeof(BITMAPINFO));

	LastTick = GetTickCount();

	m_sharp.SetRange(0,255);
	m_cover.SetRange(0,255);
	m_cover.SetPos(128);
	m_sharp.SetPos(230);

	PrepareClouds();
	scrollcountx=0;
	scrollcounty=0;
	
	SetTimer(100,10,NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CColorsDlg::PrepareClouds()
{
	m_lastc = m_cover.GetPos();
	m_lasts = m_sharp.GetPos();
	m_MainCloud[0].CreateClouds(1,BITMAPWIDTH,BITMAPHEIGHT,1,m_lastc,m_lasts);
	m_MainCloud[1].CreateClouds(2,BITMAPWIDTH,BITMAPHEIGHT,2,m_lastc,m_lasts);
	m_MainCloud[2].CreateClouds(3,BITMAPWIDTH,BITMAPHEIGHT,3,m_lastc,m_lasts);
	m_MainCloud[0].RollCloud(1*scrollcountx,1*scrollcounty);
	m_MainCloud[1].RollCloud(2*scrollcountx,2*scrollcounty);
	m_MainCloud[2].RollCloud(3*scrollcountx,3*scrollcounty);
}


void CColorsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	} else
	{
		CPaintDC dc(this); // device context for painting
	}
}

HCURSOR CColorsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CColorsDlg::OnTimer(UINT nIDEvent) 
{
	static int p =0;
	if (nIDEvent==100)
	{
		KillTimer(100);
		int dx,dy;
		POINT pt;

		GetCursorPos(&pt);
		ScreenToClient(&pt);

		dx = (pt.x/(BITMAPWIDTH/6))-2;
		dy = (pt.y/(BITMAPHEIGHT/6))-2;
		
		if (dx < -1) dx = -1;
		if (dy < -1) dy = -1;
		if (dx > 1) dx = 1;
		if (dy > 1) dy = 1;

		// Check if sliders moved.
		if ((m_lastc != m_cover.GetPos()) || (m_lasts != m_sharp.GetPos())) PrepareClouds();

		HDC dc = ::GetDC(m_hWnd);
		HDC hBMPDC = CreateCompatibleDC(dc);
		HBITMAP hBmp = m_MainCloud[0].AnimateClouds(SKY_COLOR,m_lastc,&m_MainCloud[0],&m_MainCloud[1],&m_MainCloud[2],NULL);
		HGDIOBJ hOld = SelectObject(hBMPDC,hBmp);
	
		BitBlt(dc,0,0,m_MainCloud[0].GetWidth(),m_MainCloud[0].GetHeight(),hBMPDC,0,0,SRCCOPY);
		SelectObject(hBMPDC,hOld);DeleteObject(hBmp);

		DeleteObject(hBMPDC);
		
		::ReleaseDC(m_hWnd,dc);

		m_MainCloud[0].RollCloud(dx,dy);
		m_MainCloud[1].RollCloud(dx*2,dy*2);
		m_MainCloud[2].RollCloud(dx*3,dy*3);

		scrollcountx+=dx;
		scrollcounty+=dy;
		
		

		SetTimer(100,SPEED,NULL);
		
	}
	CDialog::OnTimer(nIDEvent);
}

void CColorsDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	DeleteObject(bmphandle);
}
